'''
Created on Nov 20, 2017

@author: Charlie McLouth
'''
from flask import request
from flask_restful import Resource
from p4rest.flask.util import require_session
from werkzeug.datastructures import MultiDict

class Debugging(Resource):
    def _castValue(self, value):
        if value is None:
            return "None"
        elif isinstance(value, MultiDict):
            retValue = {}
            for k in value.keys():
                retValue[k] = value.getlist(k)
            return retValue
        elif isinstance(value, list) or isinstance(value, dict) \
                or isinstance(value, str) or isinstance(value, int):
            return value
        return dict(value)

    def _generatePayload(self, payload={}):
        #environ
        for name in ["authorization", "headers", "remote_addr", "form", "args", "values", 
                     "cookies", "method", "path", 
                     "full_path", "script_root", "url", "base_url",
                     "url_root", "view_args", "data"]:
            if name == "remote_addr":
                value = request.headers.get('X-Forwarded-For', request.remote_addr)
            elif name == "data":
#                 value = request.data
                if request.data is not None:
                    if request.is_json:
                        value = request.get_json()
                    else:
                        value = request.data
                else:
                    value = None
#             elif name == "authorization":
            else:
                value = getattr(request, name)
            payload[name] = self._castValue(value)
        return payload

    def get(self, command=None, **kwargs):
        #command = kwargs.get("command", "None")
        payload = {"command": command}
        return self._generatePayload(payload)

    def post(self, command=None, **kwargs):
        payload = {"command": command}
        return self._generatePayload(payload)

class Debugging2(Debugging):
    @require_session
    def get(self, command=None, **kwargs):
        payload = {"command": command}
        return self._generatePayload(payload)

    @require_session
    def post(self, command=None, **kwargs):
        payload = {"command": command}
        return self._generatePayload(payload)
